# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.10
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.



from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_channels_swig', [dirname(__file__)])
        except ImportError:
            import _channels_swig
            return _channels_swig
        if fp is not None:
            try:
                _mod = imp.load_module('_channels_swig', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _channels_swig = swig_import_helper()
    del swig_import_helper
else:
    import _channels_swig
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


def _swig_setattr_nondynamic_method(set):
    def set_attr(self,name,value):
        if (name == "thisown"): return self.this.own(value)
        if hasattr(self,name) or (name == "this"):
            set(self,name,value)
        else:
            raise AttributeError("You cannot add attributes to %s" % self)
    return set_attr


class channel_model(object):
    """
    channel simulator

    This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms. This model allows the user to set the voltage of an AWGN noise source, a (normalized) frequency offset, a sample timing offset, and a noise seed to randomize the AWGN noise source.

    Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile..

    Constructor Specific Documentation:

    Build the channel simulator.

    Args:
        noise_voltage : The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
        frequency_offset : The normalized frequency offset. 0 is no offset; 0.25 would be, for a digital modem, one quarter of the symbol rate.
        epsilon : The sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
        taps : Taps of a FIR filter to emulate a multipath delay profile.
        noise_seed : A random number generator seed for the noise source.
    """
    thisown = _swig_property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc='The membership flag')
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def make(*args, **kwargs):
        """
        make(double noise_voltage=0.0, double frequency_offset=0.0, double epsilon=1.0, pmt_vector_cfloat taps=std::vector< gr_complex >(1,1), 
            double noise_seed=0) -> channel_model_sptr

        channel simulator

        This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms. This model allows the user to set the voltage of an AWGN noise source, a (normalized) frequency offset, a sample timing offset, and a noise seed to randomize the AWGN noise source.

        Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile..

        Constructor Specific Documentation:

        Build the channel simulator.

        Args:
            noise_voltage : The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
            frequency_offset : The normalized frequency offset. 0 is no offset; 0.25 would be, for a digital modem, one quarter of the symbol rate.
            epsilon : The sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
            taps : Taps of a FIR filter to emulate a multipath delay profile.
            noise_seed : A random number generator seed for the noise source.
        """
        return _channels_swig.channel_model_make(*args, **kwargs)

    make = staticmethod(make)
    def set_noise_voltage(self, *args, **kwargs):
        """set_noise_voltage(channel_model self, double noise_voltage)"""
        return _channels_swig.channel_model_set_noise_voltage(self, *args, **kwargs)

    def set_frequency_offset(self, *args, **kwargs):
        """set_frequency_offset(channel_model self, double frequency_offset)"""
        return _channels_swig.channel_model_set_frequency_offset(self, *args, **kwargs)

    def set_taps(self, *args, **kwargs):
        """set_taps(channel_model self, pmt_vector_cfloat taps)"""
        return _channels_swig.channel_model_set_taps(self, *args, **kwargs)

    def set_timing_offset(self, *args, **kwargs):
        """set_timing_offset(channel_model self, double epsilon)"""
        return _channels_swig.channel_model_set_timing_offset(self, *args, **kwargs)

    def noise_voltage(self):
        """noise_voltage(channel_model self) -> double"""
        return _channels_swig.channel_model_noise_voltage(self)

    def frequency_offset(self):
        """frequency_offset(channel_model self) -> double"""
        return _channels_swig.channel_model_frequency_offset(self)

    def taps(self):
        """taps(channel_model self) -> pmt_vector_cfloat"""
        return _channels_swig.channel_model_taps(self)

    def timing_offset(self):
        """timing_offset(channel_model self) -> double"""
        return _channels_swig.channel_model_timing_offset(self)

    __swig_destroy__ = _channels_swig.delete_channel_model
    __del__ = lambda self : None;
channel_model_swigregister = _channels_swig.channel_model_swigregister
channel_model_swigregister(channel_model)

def channel_model_make(*args, **kwargs):
  """
    channel_model_make(double noise_voltage=0.0, double frequency_offset=0.0, double epsilon=1.0, pmt_vector_cfloat taps=std::vector< gr_complex >(1,1), 
        double noise_seed=0) -> channel_model_sptr

    channel simulator

    This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms. This model allows the user to set the voltage of an AWGN noise source, a (normalized) frequency offset, a sample timing offset, and a noise seed to randomize the AWGN noise source.

    Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile..

    Constructor Specific Documentation:

    Build the channel simulator.

    Args:
        noise_voltage : The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
        frequency_offset : The normalized frequency offset. 0 is no offset; 0.25 would be, for a digital modem, one quarter of the symbol rate.
        epsilon : The sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
        taps : Taps of a FIR filter to emulate a multipath delay profile.
        noise_seed : A random number generator seed for the noise source.
    """
  return _channels_swig.channel_model_make(*args, **kwargs)

class channel_model2(object):
    """
    channel model2

    This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

    This model allows the user to set the voltage of an AWGN noise source, an initial timing offset, and a noise seed to randomize the AWGN noise source.

    Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile.

    Unlike gr::channels::channel_model, this block is designed to enable time-varying frequency and timing offsets.


    Since the models for frequency and timing offset may vary and what we are trying to model may be different for different simulations, we provide the time-varying nature as an input function that is user-defined. If only constant frequency and timing offsets are required, it is easier and less expensive to use gr::channels::channel_model.

    Constructor Specific Documentation:

    Build the channel simulator.

    Args:
        noise_voltage : The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
        epsilon : The initial sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
        taps : Taps of a FIR filter to emulate a multipath delay profile.
        noise_seed : A random number generator seed for the noise source.
    """
    thisown = _swig_property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc='The membership flag')
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def make(*args, **kwargs):
        """
        make(double noise_voltage=0.0, double epsilon=1.0, pmt_vector_cfloat taps=std::vector< gr_complex >(1,1), 
            double noise_seed=0) -> channel_model2_sptr

        channel model2

        This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

        This model allows the user to set the voltage of an AWGN noise source, an initial timing offset, and a noise seed to randomize the AWGN noise source.

        Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile.

        Unlike gr::channels::channel_model, this block is designed to enable time-varying frequency and timing offsets.


        Since the models for frequency and timing offset may vary and what we are trying to model may be different for different simulations, we provide the time-varying nature as an input function that is user-defined. If only constant frequency and timing offsets are required, it is easier and less expensive to use gr::channels::channel_model.

        Constructor Specific Documentation:

        Build the channel simulator.

        Args:
            noise_voltage : The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
            epsilon : The initial sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
            taps : Taps of a FIR filter to emulate a multipath delay profile.
            noise_seed : A random number generator seed for the noise source.
        """
        return _channels_swig.channel_model2_make(*args, **kwargs)

    make = staticmethod(make)
    def set_noise_voltage(self, *args, **kwargs):
        """set_noise_voltage(channel_model2 self, double noise_voltage)"""
        return _channels_swig.channel_model2_set_noise_voltage(self, *args, **kwargs)

    def set_taps(self, *args, **kwargs):
        """set_taps(channel_model2 self, pmt_vector_cfloat taps)"""
        return _channels_swig.channel_model2_set_taps(self, *args, **kwargs)

    def set_timing_offset(self, *args, **kwargs):
        """set_timing_offset(channel_model2 self, double epsilon)"""
        return _channels_swig.channel_model2_set_timing_offset(self, *args, **kwargs)

    def noise_voltage(self):
        """noise_voltage(channel_model2 self) -> double"""
        return _channels_swig.channel_model2_noise_voltage(self)

    def taps(self):
        """taps(channel_model2 self) -> pmt_vector_cfloat"""
        return _channels_swig.channel_model2_taps(self)

    def timing_offset(self):
        """timing_offset(channel_model2 self) -> double"""
        return _channels_swig.channel_model2_timing_offset(self)

    __swig_destroy__ = _channels_swig.delete_channel_model2
    __del__ = lambda self : None;
channel_model2_swigregister = _channels_swig.channel_model2_swigregister
channel_model2_swigregister(channel_model2)

def channel_model2_make(*args, **kwargs):
  """
    channel_model2_make(double noise_voltage=0.0, double epsilon=1.0, pmt_vector_cfloat taps=std::vector< gr_complex >(1,1), 
        double noise_seed=0) -> channel_model2_sptr

    channel model2

    This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

    This model allows the user to set the voltage of an AWGN noise source, an initial timing offset, and a noise seed to randomize the AWGN noise source.

    Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile.

    Unlike gr::channels::channel_model, this block is designed to enable time-varying frequency and timing offsets.


    Since the models for frequency and timing offset may vary and what we are trying to model may be different for different simulations, we provide the time-varying nature as an input function that is user-defined. If only constant frequency and timing offsets are required, it is easier and less expensive to use gr::channels::channel_model.

    Constructor Specific Documentation:

    Build the channel simulator.

    Args:
        noise_voltage : The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
        epsilon : The initial sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
        taps : Taps of a FIR filter to emulate a multipath delay profile.
        noise_seed : A random number generator seed for the noise source.
    """
  return _channels_swig.channel_model2_make(*args, **kwargs)

class fading_model(object):
    """
    fading simulator

    This block implements a basic fading model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

    Constructor Specific Documentation:

    Build the channel simulator.

    Args:
        N : The number of sinusiods to use in simulating the channel; 8 is a good value
        fDTs : normalized maximum Doppler frequency, fD * Ts
        LOS : include Line-of-Site path? selects between Rayleigh (NLOS) and Rician (LOS) models
        K : Rician factor (ratio of the specular power to the scattered power)
        seed : a random number to seed the noise generators
    """
    thisown = _swig_property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc='The membership flag')
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def make(*args, **kwargs):
        """
        make(unsigned int N, float fDTs=0.01, bool LOS=True, float K=4, int seed=0) -> fading_model_sptr

        fading simulator

        This block implements a basic fading model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

        Constructor Specific Documentation:

        Build the channel simulator.

        Args:
            N : The number of sinusiods to use in simulating the channel; 8 is a good value
            fDTs : normalized maximum Doppler frequency, fD * Ts
            LOS : include Line-of-Site path? selects between Rayleigh (NLOS) and Rician (LOS) models
            K : Rician factor (ratio of the specular power to the scattered power)
            seed : a random number to seed the noise generators
        """
        return _channels_swig.fading_model_make(*args, **kwargs)

    make = staticmethod(make)
    def fDTs(self):
        """fDTs(fading_model self) -> float"""
        return _channels_swig.fading_model_fDTs(self)

    def K(self):
        """K(fading_model self) -> float"""
        return _channels_swig.fading_model_K(self)

    def step(self):
        """step(fading_model self) -> float"""
        return _channels_swig.fading_model_step(self)

    def set_fDTs(self, *args, **kwargs):
        """set_fDTs(fading_model self, float fDTs)"""
        return _channels_swig.fading_model_set_fDTs(self, *args, **kwargs)

    def set_K(self, *args, **kwargs):
        """set_K(fading_model self, float K)"""
        return _channels_swig.fading_model_set_K(self, *args, **kwargs)

    def set_step(self, *args, **kwargs):
        """set_step(fading_model self, float step)"""
        return _channels_swig.fading_model_set_step(self, *args, **kwargs)

    __swig_destroy__ = _channels_swig.delete_fading_model
    __del__ = lambda self : None;
fading_model_swigregister = _channels_swig.fading_model_swigregister
fading_model_swigregister(fading_model)

def fading_model_make(*args, **kwargs):
  """
    fading_model_make(unsigned int N, float fDTs=0.01, bool LOS=True, float K=4, int seed=0) -> fading_model_sptr

    fading simulator

    This block implements a basic fading model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

    Constructor Specific Documentation:

    Build the channel simulator.

    Args:
        N : The number of sinusiods to use in simulating the channel; 8 is a good value
        fDTs : normalized maximum Doppler frequency, fD * Ts
        LOS : include Line-of-Site path? selects between Rayleigh (NLOS) and Rician (LOS) models
        K : Rician factor (ratio of the specular power to the scattered power)
        seed : a random number to seed the noise generators
    """
  return _channels_swig.fading_model_make(*args, **kwargs)

class selective_fading_model(object):
    """
    fading simulator

    This block implements a basic fading model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

    Constructor Specific Documentation:

    Build the channel simulator.

    Args:
        N : The number of sinusiods to use in simulating the channel; 8 is a good value
        fDTs : normalized maximum Doppler frequency, fD * Ts
        LOS : include Line-of-Site path? selects between Rayleigh (NLOS) and Rician (LOS) models
        K : Rician factor (ratio of the specular power to the scattered power)
        seed : a random number to seed the noise generators
        delays : A vector of values the specify the time delay of each impulse
        mags : A vector of values that specifies the magnitude of each impulse
        ntaps : The number of filter taps.
    """
    thisown = _swig_property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc='The membership flag')
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    def make(*args, **kwargs):
        """
        make(unsigned int N, float fDTs, bool LOS, float K, int seed, pmt_vector_float delays, 
            pmt_vector_float mags, int ntaps) -> selective_fading_model_sptr

        fading simulator

        This block implements a basic fading model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

        Constructor Specific Documentation:

        Build the channel simulator.

        Args:
            N : The number of sinusiods to use in simulating the channel; 8 is a good value
            fDTs : normalized maximum Doppler frequency, fD * Ts
            LOS : include Line-of-Site path? selects between Rayleigh (NLOS) and Rician (LOS) models
            K : Rician factor (ratio of the specular power to the scattered power)
            seed : a random number to seed the noise generators
            delays : A vector of values the specify the time delay of each impulse
            mags : A vector of values that specifies the magnitude of each impulse
            ntaps : The number of filter taps.
        """
        return _channels_swig.selective_fading_model_make(*args, **kwargs)

    make = staticmethod(make)
    def fDTs(self):
        """fDTs(selective_fading_model self) -> float"""
        return _channels_swig.selective_fading_model_fDTs(self)

    def K(self):
        """K(selective_fading_model self) -> float"""
        return _channels_swig.selective_fading_model_K(self)

    def step(self):
        """step(selective_fading_model self) -> float"""
        return _channels_swig.selective_fading_model_step(self)

    def set_fDTs(self, *args, **kwargs):
        """set_fDTs(selective_fading_model self, float fDTs)"""
        return _channels_swig.selective_fading_model_set_fDTs(self, *args, **kwargs)

    def set_K(self, *args, **kwargs):
        """set_K(selective_fading_model self, float K)"""
        return _channels_swig.selective_fading_model_set_K(self, *args, **kwargs)

    def set_step(self, *args, **kwargs):
        """set_step(selective_fading_model self, float step)"""
        return _channels_swig.selective_fading_model_set_step(self, *args, **kwargs)

    __swig_destroy__ = _channels_swig.delete_selective_fading_model
    __del__ = lambda self : None;
selective_fading_model_swigregister = _channels_swig.selective_fading_model_swigregister
selective_fading_model_swigregister(selective_fading_model)
cvar = _channels_swig.cvar
default_delays = cvar.default_delays
default_mags = cvar.default_mags

def selective_fading_model_make(*args, **kwargs):
  """
    selective_fading_model_make(unsigned int N, float fDTs, bool LOS, float K, int seed, pmt_vector_float delays, 
        pmt_vector_float mags, int ntaps) -> selective_fading_model_sptr

    fading simulator

    This block implements a basic fading model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

    Constructor Specific Documentation:

    Build the channel simulator.

    Args:
        N : The number of sinusiods to use in simulating the channel; 8 is a good value
        fDTs : normalized maximum Doppler frequency, fD * Ts
        LOS : include Line-of-Site path? selects between Rayleigh (NLOS) and Rician (LOS) models
        K : Rician factor (ratio of the specular power to the scattered power)
        seed : a random number to seed the noise generators
        delays : A vector of values the specify the time delay of each impulse
        mags : A vector of values that specifies the magnitude of each impulse
        ntaps : The number of filter taps.
    """
  return _channels_swig.selective_fading_model_make(*args, **kwargs)

class channel_model_sptr(object):
    """Proxy of C++ boost::shared_ptr<(gr::channels::channel_model)> class"""
    thisown = _swig_property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc='The membership flag')
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(boost::shared_ptr<(gr::channels::channel_model)> self) -> channel_model_sptr
        __init__(boost::shared_ptr<(gr::channels::channel_model)> self, channel_model p) -> channel_model_sptr
        """
        this = _channels_swig.new_channel_model_sptr(*args)
        try: self.this.append(this)
        except: self.this = this
    def __deref__(self):
        """__deref__(channel_model_sptr self) -> channel_model"""
        return _channels_swig.channel_model_sptr___deref__(self)

    __swig_destroy__ = _channels_swig.delete_channel_model_sptr
    __del__ = lambda self : None;
    def make(self, *args, **kwargs):
        """
        make(channel_model_sptr self, double noise_voltage=0.0, double frequency_offset=0.0, double epsilon=1.0, pmt_vector_cfloat taps=std::vector< gr_complex >(1,1), 
            double noise_seed=0) -> channel_model_sptr

        channel simulator

        This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms. This model allows the user to set the voltage of an AWGN noise source, a (normalized) frequency offset, a sample timing offset, and a noise seed to randomize the AWGN noise source.

        Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile..

        Constructor Specific Documentation:

        Build the channel simulator.

        Args:
            noise_voltage : The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
            frequency_offset : The normalized frequency offset. 0 is no offset; 0.25 would be, for a digital modem, one quarter of the symbol rate.
            epsilon : The sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
            taps : Taps of a FIR filter to emulate a multipath delay profile.
            noise_seed : A random number generator seed for the noise source.
        """
        return _channels_swig.channel_model_sptr_make(self, *args, **kwargs)

    def set_noise_voltage(self, *args, **kwargs):
        """set_noise_voltage(channel_model_sptr self, double noise_voltage)"""
        return _channels_swig.channel_model_sptr_set_noise_voltage(self, *args, **kwargs)

    def set_frequency_offset(self, *args, **kwargs):
        """set_frequency_offset(channel_model_sptr self, double frequency_offset)"""
        return _channels_swig.channel_model_sptr_set_frequency_offset(self, *args, **kwargs)

    def set_taps(self, *args, **kwargs):
        """set_taps(channel_model_sptr self, pmt_vector_cfloat taps)"""
        return _channels_swig.channel_model_sptr_set_taps(self, *args, **kwargs)

    def set_timing_offset(self, *args, **kwargs):
        """set_timing_offset(channel_model_sptr self, double epsilon)"""
        return _channels_swig.channel_model_sptr_set_timing_offset(self, *args, **kwargs)

    def noise_voltage(self):
        """noise_voltage(channel_model_sptr self) -> double"""
        return _channels_swig.channel_model_sptr_noise_voltage(self)

    def frequency_offset(self):
        """frequency_offset(channel_model_sptr self) -> double"""
        return _channels_swig.channel_model_sptr_frequency_offset(self)

    def taps(self):
        """taps(channel_model_sptr self) -> pmt_vector_cfloat"""
        return _channels_swig.channel_model_sptr_taps(self)

    def timing_offset(self):
        """timing_offset(channel_model_sptr self) -> double"""
        return _channels_swig.channel_model_sptr_timing_offset(self)

    def primitive_connect(self, *args):
        """
        primitive_connect(channel_model_sptr self, basic_block_sptr block)
        primitive_connect(channel_model_sptr self, basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
        """
        return _channels_swig.channel_model_sptr_primitive_connect(self, *args)

    def primitive_msg_connect(self, *args):
        """
        primitive_msg_connect(channel_model_sptr self, basic_block_sptr src, swig_int_ptr srcport, basic_block_sptr dst, swig_int_ptr dstport)
        primitive_msg_connect(channel_model_sptr self, basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
        """
        return _channels_swig.channel_model_sptr_primitive_msg_connect(self, *args)

    def primitive_msg_disconnect(self, *args):
        """
        primitive_msg_disconnect(channel_model_sptr self, basic_block_sptr src, swig_int_ptr srcport, basic_block_sptr dst, swig_int_ptr dstport)
        primitive_msg_disconnect(channel_model_sptr self, basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
        """
        return _channels_swig.channel_model_sptr_primitive_msg_disconnect(self, *args)

    def primitive_disconnect(self, *args):
        """
        primitive_disconnect(channel_model_sptr self, basic_block_sptr block)
        primitive_disconnect(channel_model_sptr self, basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
        """
        return _channels_swig.channel_model_sptr_primitive_disconnect(self, *args)

    def disconnect_all(self):
        """disconnect_all(channel_model_sptr self)"""
        return _channels_swig.channel_model_sptr_disconnect_all(self)

    def lock(self):
        """lock(channel_model_sptr self)"""
        return _channels_swig.channel_model_sptr_lock(self)

    def unlock(self):
        """unlock(channel_model_sptr self)"""
        return _channels_swig.channel_model_sptr_unlock(self)

    def primitive_message_port_register_hier_in(self, *args, **kwargs):
        """primitive_message_port_register_hier_in(channel_model_sptr self, swig_int_ptr port_id)"""
        return _channels_swig.channel_model_sptr_primitive_message_port_register_hier_in(self, *args, **kwargs)

    def primitive_message_port_register_hier_out(self, *args, **kwargs):
        """primitive_message_port_register_hier_out(channel_model_sptr self, swig_int_ptr port_id)"""
        return _channels_swig.channel_model_sptr_primitive_message_port_register_hier_out(self, *args, **kwargs)

    def set_processor_affinity(self, *args, **kwargs):
        """set_processor_affinity(channel_model_sptr self, std::vector< int,std::allocator< int > > const & mask)"""
        return _channels_swig.channel_model_sptr_set_processor_affinity(self, *args, **kwargs)

    def unset_processor_affinity(self):
        """unset_processor_affinity(channel_model_sptr self)"""
        return _channels_swig.channel_model_sptr_unset_processor_affinity(self)

    def processor_affinity(self):
        """processor_affinity(channel_model_sptr self) -> std::vector< int,std::allocator< int > >"""
        return _channels_swig.channel_model_sptr_processor_affinity(self)

    def to_hier_block2(self):
        """to_hier_block2(channel_model_sptr self) -> hier_block2_sptr"""
        return _channels_swig.channel_model_sptr_to_hier_block2(self)

    def name(self):
        """name(channel_model_sptr self) -> std::string"""
        return _channels_swig.channel_model_sptr_name(self)

    def symbol_name(self):
        """symbol_name(channel_model_sptr self) -> std::string"""
        return _channels_swig.channel_model_sptr_symbol_name(self)

    def input_signature(self):
        """input_signature(channel_model_sptr self) -> io_signature_sptr"""
        return _channels_swig.channel_model_sptr_input_signature(self)

    def output_signature(self):
        """output_signature(channel_model_sptr self) -> io_signature_sptr"""
        return _channels_swig.channel_model_sptr_output_signature(self)

    def unique_id(self):
        """unique_id(channel_model_sptr self) -> long"""
        return _channels_swig.channel_model_sptr_unique_id(self)

    def to_basic_block(self):
        """to_basic_block(channel_model_sptr self) -> basic_block_sptr"""
        return _channels_swig.channel_model_sptr_to_basic_block(self)

    def check_topology(self, *args, **kwargs):
        """check_topology(channel_model_sptr self, int ninputs, int noutputs) -> bool"""
        return _channels_swig.channel_model_sptr_check_topology(self, *args, **kwargs)

    def alias(self):
        """alias(channel_model_sptr self) -> std::string"""
        return _channels_swig.channel_model_sptr_alias(self)

    def set_block_alias(self, *args, **kwargs):
        """set_block_alias(channel_model_sptr self, std::string name)"""
        return _channels_swig.channel_model_sptr_set_block_alias(self, *args, **kwargs)

    def _post(self, *args, **kwargs):
        """_post(channel_model_sptr self, swig_int_ptr which_port, swig_int_ptr msg)"""
        return _channels_swig.channel_model_sptr__post(self, *args, **kwargs)

    def message_ports_in(self):
        """message_ports_in(channel_model_sptr self) -> swig_int_ptr"""
        return _channels_swig.channel_model_sptr_message_ports_in(self)

    def message_ports_out(self):
        """message_ports_out(channel_model_sptr self) -> swig_int_ptr"""
        return _channels_swig.channel_model_sptr_message_ports_out(self)

channel_model_sptr_swigregister = _channels_swig.channel_model_sptr_swigregister
channel_model_sptr_swigregister(channel_model_sptr)

channel_model_sptr.__repr__ = lambda self: "<gr_block %s (%d)>" % (self.name(), self.unique_id())
channel_model = channel_model.make;

class channel_model2_sptr(object):
    """Proxy of C++ boost::shared_ptr<(gr::channels::channel_model2)> class"""
    thisown = _swig_property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc='The membership flag')
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(boost::shared_ptr<(gr::channels::channel_model2)> self) -> channel_model2_sptr
        __init__(boost::shared_ptr<(gr::channels::channel_model2)> self, channel_model2 p) -> channel_model2_sptr
        """
        this = _channels_swig.new_channel_model2_sptr(*args)
        try: self.this.append(this)
        except: self.this = this
    def __deref__(self):
        """__deref__(channel_model2_sptr self) -> channel_model2"""
        return _channels_swig.channel_model2_sptr___deref__(self)

    __swig_destroy__ = _channels_swig.delete_channel_model2_sptr
    __del__ = lambda self : None;
    def make(self, *args, **kwargs):
        """
        make(channel_model2_sptr self, double noise_voltage=0.0, double epsilon=1.0, pmt_vector_cfloat taps=std::vector< gr_complex >(1,1), 
            double noise_seed=0) -> channel_model2_sptr

        channel model2

        This block implements a basic channel model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

        This model allows the user to set the voltage of an AWGN noise source, an initial timing offset, and a noise seed to randomize the AWGN noise source.

        Multipath can be approximated in this model by using a FIR filter representation of a multipath delay profile.

        Unlike gr::channels::channel_model, this block is designed to enable time-varying frequency and timing offsets.


        Since the models for frequency and timing offset may vary and what we are trying to model may be different for different simulations, we provide the time-varying nature as an input function that is user-defined. If only constant frequency and timing offsets are required, it is easier and less expensive to use gr::channels::channel_model.

        Constructor Specific Documentation:

        Build the channel simulator.

        Args:
            noise_voltage : The AWGN noise level as a voltage (to be calculated externally to meet, say, a desired SNR).
            epsilon : The initial sample timing offset to emulate the different rates between the sample clocks of the transmitter and receiver. 1.0 is no difference.
            taps : Taps of a FIR filter to emulate a multipath delay profile.
            noise_seed : A random number generator seed for the noise source.
        """
        return _channels_swig.channel_model2_sptr_make(self, *args, **kwargs)

    def set_noise_voltage(self, *args, **kwargs):
        """set_noise_voltage(channel_model2_sptr self, double noise_voltage)"""
        return _channels_swig.channel_model2_sptr_set_noise_voltage(self, *args, **kwargs)

    def set_taps(self, *args, **kwargs):
        """set_taps(channel_model2_sptr self, pmt_vector_cfloat taps)"""
        return _channels_swig.channel_model2_sptr_set_taps(self, *args, **kwargs)

    def set_timing_offset(self, *args, **kwargs):
        """set_timing_offset(channel_model2_sptr self, double epsilon)"""
        return _channels_swig.channel_model2_sptr_set_timing_offset(self, *args, **kwargs)

    def noise_voltage(self):
        """noise_voltage(channel_model2_sptr self) -> double"""
        return _channels_swig.channel_model2_sptr_noise_voltage(self)

    def taps(self):
        """taps(channel_model2_sptr self) -> pmt_vector_cfloat"""
        return _channels_swig.channel_model2_sptr_taps(self)

    def timing_offset(self):
        """timing_offset(channel_model2_sptr self) -> double"""
        return _channels_swig.channel_model2_sptr_timing_offset(self)

    def primitive_connect(self, *args):
        """
        primitive_connect(channel_model2_sptr self, basic_block_sptr block)
        primitive_connect(channel_model2_sptr self, basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
        """
        return _channels_swig.channel_model2_sptr_primitive_connect(self, *args)

    def primitive_msg_connect(self, *args):
        """
        primitive_msg_connect(channel_model2_sptr self, basic_block_sptr src, swig_int_ptr srcport, basic_block_sptr dst, swig_int_ptr dstport)
        primitive_msg_connect(channel_model2_sptr self, basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
        """
        return _channels_swig.channel_model2_sptr_primitive_msg_connect(self, *args)

    def primitive_msg_disconnect(self, *args):
        """
        primitive_msg_disconnect(channel_model2_sptr self, basic_block_sptr src, swig_int_ptr srcport, basic_block_sptr dst, swig_int_ptr dstport)
        primitive_msg_disconnect(channel_model2_sptr self, basic_block_sptr src, std::string srcport, basic_block_sptr dst, std::string dstport)
        """
        return _channels_swig.channel_model2_sptr_primitive_msg_disconnect(self, *args)

    def primitive_disconnect(self, *args):
        """
        primitive_disconnect(channel_model2_sptr self, basic_block_sptr block)
        primitive_disconnect(channel_model2_sptr self, basic_block_sptr src, int src_port, basic_block_sptr dst, int dst_port)
        """
        return _channels_swig.channel_model2_sptr_primitive_disconnect(self, *args)

    def disconnect_all(self):
        """disconnect_all(channel_model2_sptr self)"""
        return _channels_swig.channel_model2_sptr_disconnect_all(self)

    def lock(self):
        """lock(channel_model2_sptr self)"""
        return _channels_swig.channel_model2_sptr_lock(self)

    def unlock(self):
        """unlock(channel_model2_sptr self)"""
        return _channels_swig.channel_model2_sptr_unlock(self)

    def primitive_message_port_register_hier_in(self, *args, **kwargs):
        """primitive_message_port_register_hier_in(channel_model2_sptr self, swig_int_ptr port_id)"""
        return _channels_swig.channel_model2_sptr_primitive_message_port_register_hier_in(self, *args, **kwargs)

    def primitive_message_port_register_hier_out(self, *args, **kwargs):
        """primitive_message_port_register_hier_out(channel_model2_sptr self, swig_int_ptr port_id)"""
        return _channels_swig.channel_model2_sptr_primitive_message_port_register_hier_out(self, *args, **kwargs)

    def set_processor_affinity(self, *args, **kwargs):
        """set_processor_affinity(channel_model2_sptr self, std::vector< int,std::allocator< int > > const & mask)"""
        return _channels_swig.channel_model2_sptr_set_processor_affinity(self, *args, **kwargs)

    def unset_processor_affinity(self):
        """unset_processor_affinity(channel_model2_sptr self)"""
        return _channels_swig.channel_model2_sptr_unset_processor_affinity(self)

    def processor_affinity(self):
        """processor_affinity(channel_model2_sptr self) -> std::vector< int,std::allocator< int > >"""
        return _channels_swig.channel_model2_sptr_processor_affinity(self)

    def to_hier_block2(self):
        """to_hier_block2(channel_model2_sptr self) -> hier_block2_sptr"""
        return _channels_swig.channel_model2_sptr_to_hier_block2(self)

    def name(self):
        """name(channel_model2_sptr self) -> std::string"""
        return _channels_swig.channel_model2_sptr_name(self)

    def symbol_name(self):
        """symbol_name(channel_model2_sptr self) -> std::string"""
        return _channels_swig.channel_model2_sptr_symbol_name(self)

    def input_signature(self):
        """input_signature(channel_model2_sptr self) -> io_signature_sptr"""
        return _channels_swig.channel_model2_sptr_input_signature(self)

    def output_signature(self):
        """output_signature(channel_model2_sptr self) -> io_signature_sptr"""
        return _channels_swig.channel_model2_sptr_output_signature(self)

    def unique_id(self):
        """unique_id(channel_model2_sptr self) -> long"""
        return _channels_swig.channel_model2_sptr_unique_id(self)

    def to_basic_block(self):
        """to_basic_block(channel_model2_sptr self) -> basic_block_sptr"""
        return _channels_swig.channel_model2_sptr_to_basic_block(self)

    def check_topology(self, *args, **kwargs):
        """check_topology(channel_model2_sptr self, int ninputs, int noutputs) -> bool"""
        return _channels_swig.channel_model2_sptr_check_topology(self, *args, **kwargs)

    def alias(self):
        """alias(channel_model2_sptr self) -> std::string"""
        return _channels_swig.channel_model2_sptr_alias(self)

    def set_block_alias(self, *args, **kwargs):
        """set_block_alias(channel_model2_sptr self, std::string name)"""
        return _channels_swig.channel_model2_sptr_set_block_alias(self, *args, **kwargs)

    def _post(self, *args, **kwargs):
        """_post(channel_model2_sptr self, swig_int_ptr which_port, swig_int_ptr msg)"""
        return _channels_swig.channel_model2_sptr__post(self, *args, **kwargs)

    def message_ports_in(self):
        """message_ports_in(channel_model2_sptr self) -> swig_int_ptr"""
        return _channels_swig.channel_model2_sptr_message_ports_in(self)

    def message_ports_out(self):
        """message_ports_out(channel_model2_sptr self) -> swig_int_ptr"""
        return _channels_swig.channel_model2_sptr_message_ports_out(self)

channel_model2_sptr_swigregister = _channels_swig.channel_model2_sptr_swigregister
channel_model2_sptr_swigregister(channel_model2_sptr)

channel_model2_sptr.__repr__ = lambda self: "<gr_block %s (%d)>" % (self.name(), self.unique_id())
channel_model2 = channel_model2.make;

class fading_model_sptr(object):
    """Proxy of C++ boost::shared_ptr<(gr::channels::fading_model)> class"""
    thisown = _swig_property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc='The membership flag')
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(boost::shared_ptr<(gr::channels::fading_model)> self) -> fading_model_sptr
        __init__(boost::shared_ptr<(gr::channels::fading_model)> self, fading_model p) -> fading_model_sptr
        """
        this = _channels_swig.new_fading_model_sptr(*args)
        try: self.this.append(this)
        except: self.this = this
    def __deref__(self):
        """__deref__(fading_model_sptr self) -> fading_model"""
        return _channels_swig.fading_model_sptr___deref__(self)

    __swig_destroy__ = _channels_swig.delete_fading_model_sptr
    __del__ = lambda self : None;
    def make(self, *args, **kwargs):
        """
        make(fading_model_sptr self, unsigned int N, float fDTs=0.01, bool LOS=True, float K=4, int seed=0) -> fading_model_sptr

        fading simulator

        This block implements a basic fading model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

        Constructor Specific Documentation:

        Build the channel simulator.

        Args:
            N : The number of sinusiods to use in simulating the channel; 8 is a good value
            fDTs : normalized maximum Doppler frequency, fD * Ts
            LOS : include Line-of-Site path? selects between Rayleigh (NLOS) and Rician (LOS) models
            K : Rician factor (ratio of the specular power to the scattered power)
            seed : a random number to seed the noise generators
        """
        return _channels_swig.fading_model_sptr_make(self, *args, **kwargs)

    def fDTs(self):
        """fDTs(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_fDTs(self)

    def K(self):
        """K(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_K(self)

    def step(self):
        """step(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_step(self)

    def set_fDTs(self, *args, **kwargs):
        """set_fDTs(fading_model_sptr self, float fDTs)"""
        return _channels_swig.fading_model_sptr_set_fDTs(self, *args, **kwargs)

    def set_K(self, *args, **kwargs):
        """set_K(fading_model_sptr self, float K)"""
        return _channels_swig.fading_model_sptr_set_K(self, *args, **kwargs)

    def set_step(self, *args, **kwargs):
        """set_step(fading_model_sptr self, float step)"""
        return _channels_swig.fading_model_sptr_set_step(self, *args, **kwargs)

    def history(self):
        """history(fading_model_sptr self) -> unsigned int"""
        return _channels_swig.fading_model_sptr_history(self)

    def output_multiple(self):
        """output_multiple(fading_model_sptr self) -> int"""
        return _channels_swig.fading_model_sptr_output_multiple(self)

    def relative_rate(self):
        """relative_rate(fading_model_sptr self) -> double"""
        return _channels_swig.fading_model_sptr_relative_rate(self)

    def start(self):
        """start(fading_model_sptr self) -> bool"""
        return _channels_swig.fading_model_sptr_start(self)

    def stop(self):
        """stop(fading_model_sptr self) -> bool"""
        return _channels_swig.fading_model_sptr_stop(self)

    def nitems_read(self, *args, **kwargs):
        """nitems_read(fading_model_sptr self, unsigned int which_input) -> uint64_t"""
        return _channels_swig.fading_model_sptr_nitems_read(self, *args, **kwargs)

    def nitems_written(self, *args, **kwargs):
        """nitems_written(fading_model_sptr self, unsigned int which_output) -> uint64_t"""
        return _channels_swig.fading_model_sptr_nitems_written(self, *args, **kwargs)

    def max_noutput_items(self):
        """max_noutput_items(fading_model_sptr self) -> int"""
        return _channels_swig.fading_model_sptr_max_noutput_items(self)

    def set_max_noutput_items(self, *args, **kwargs):
        """set_max_noutput_items(fading_model_sptr self, int m)"""
        return _channels_swig.fading_model_sptr_set_max_noutput_items(self, *args, **kwargs)

    def unset_max_noutput_items(self):
        """unset_max_noutput_items(fading_model_sptr self)"""
        return _channels_swig.fading_model_sptr_unset_max_noutput_items(self)

    def is_set_max_noutput_items(self):
        """is_set_max_noutput_items(fading_model_sptr self) -> bool"""
        return _channels_swig.fading_model_sptr_is_set_max_noutput_items(self)

    def max_output_buffer(self, *args, **kwargs):
        """max_output_buffer(fading_model_sptr self, int i) -> long"""
        return _channels_swig.fading_model_sptr_max_output_buffer(self, *args, **kwargs)

    def set_max_output_buffer(self, *args):
        """
        set_max_output_buffer(fading_model_sptr self, long max_output_buffer)
        set_max_output_buffer(fading_model_sptr self, int port, long max_output_buffer)
        """
        return _channels_swig.fading_model_sptr_set_max_output_buffer(self, *args)

    def min_output_buffer(self, *args, **kwargs):
        """min_output_buffer(fading_model_sptr self, int i) -> long"""
        return _channels_swig.fading_model_sptr_min_output_buffer(self, *args, **kwargs)

    def set_min_output_buffer(self, *args):
        """
        set_min_output_buffer(fading_model_sptr self, long min_output_buffer)
        set_min_output_buffer(fading_model_sptr self, int port, long min_output_buffer)
        """
        return _channels_swig.fading_model_sptr_set_min_output_buffer(self, *args)

    def pc_noutput_items(self):
        """pc_noutput_items(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_noutput_items(self)

    def pc_noutput_items_avg(self):
        """pc_noutput_items_avg(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_noutput_items_avg(self)

    def pc_noutput_items_var(self):
        """pc_noutput_items_var(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_noutput_items_var(self)

    def pc_nproduced(self):
        """pc_nproduced(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_nproduced(self)

    def pc_nproduced_avg(self):
        """pc_nproduced_avg(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_nproduced_avg(self)

    def pc_nproduced_var(self):
        """pc_nproduced_var(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_nproduced_var(self)

    def pc_input_buffers_full(self, *args):
        """
        pc_input_buffers_full(fading_model_sptr self, int which) -> float
        pc_input_buffers_full(fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.fading_model_sptr_pc_input_buffers_full(self, *args)

    def pc_input_buffers_full_avg(self, *args):
        """
        pc_input_buffers_full_avg(fading_model_sptr self, int which) -> float
        pc_input_buffers_full_avg(fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.fading_model_sptr_pc_input_buffers_full_avg(self, *args)

    def pc_input_buffers_full_var(self, *args):
        """
        pc_input_buffers_full_var(fading_model_sptr self, int which) -> float
        pc_input_buffers_full_var(fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.fading_model_sptr_pc_input_buffers_full_var(self, *args)

    def pc_output_buffers_full(self, *args):
        """
        pc_output_buffers_full(fading_model_sptr self, int which) -> float
        pc_output_buffers_full(fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.fading_model_sptr_pc_output_buffers_full(self, *args)

    def pc_output_buffers_full_avg(self, *args):
        """
        pc_output_buffers_full_avg(fading_model_sptr self, int which) -> float
        pc_output_buffers_full_avg(fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.fading_model_sptr_pc_output_buffers_full_avg(self, *args)

    def pc_output_buffers_full_var(self, *args):
        """
        pc_output_buffers_full_var(fading_model_sptr self, int which) -> float
        pc_output_buffers_full_var(fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.fading_model_sptr_pc_output_buffers_full_var(self, *args)

    def pc_work_time(self):
        """pc_work_time(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_work_time(self)

    def pc_work_time_avg(self):
        """pc_work_time_avg(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_work_time_avg(self)

    def pc_work_time_var(self):
        """pc_work_time_var(fading_model_sptr self) -> float"""
        return _channels_swig.fading_model_sptr_pc_work_time_var(self)

    def set_processor_affinity(self, *args, **kwargs):
        """set_processor_affinity(fading_model_sptr self, std::vector< int,std::allocator< int > > const & mask)"""
        return _channels_swig.fading_model_sptr_set_processor_affinity(self, *args, **kwargs)

    def unset_processor_affinity(self):
        """unset_processor_affinity(fading_model_sptr self)"""
        return _channels_swig.fading_model_sptr_unset_processor_affinity(self)

    def processor_affinity(self):
        """processor_affinity(fading_model_sptr self) -> std::vector< int,std::allocator< int > >"""
        return _channels_swig.fading_model_sptr_processor_affinity(self)

    def active_thread_priority(self):
        """active_thread_priority(fading_model_sptr self) -> int"""
        return _channels_swig.fading_model_sptr_active_thread_priority(self)

    def thread_priority(self):
        """thread_priority(fading_model_sptr self) -> int"""
        return _channels_swig.fading_model_sptr_thread_priority(self)

    def set_thread_priority(self, *args, **kwargs):
        """set_thread_priority(fading_model_sptr self, int priority) -> int"""
        return _channels_swig.fading_model_sptr_set_thread_priority(self, *args, **kwargs)

    def name(self):
        """name(fading_model_sptr self) -> std::string"""
        return _channels_swig.fading_model_sptr_name(self)

    def symbol_name(self):
        """symbol_name(fading_model_sptr self) -> std::string"""
        return _channels_swig.fading_model_sptr_symbol_name(self)

    def input_signature(self):
        """input_signature(fading_model_sptr self) -> io_signature_sptr"""
        return _channels_swig.fading_model_sptr_input_signature(self)

    def output_signature(self):
        """output_signature(fading_model_sptr self) -> io_signature_sptr"""
        return _channels_swig.fading_model_sptr_output_signature(self)

    def unique_id(self):
        """unique_id(fading_model_sptr self) -> long"""
        return _channels_swig.fading_model_sptr_unique_id(self)

    def to_basic_block(self):
        """to_basic_block(fading_model_sptr self) -> basic_block_sptr"""
        return _channels_swig.fading_model_sptr_to_basic_block(self)

    def check_topology(self, *args, **kwargs):
        """check_topology(fading_model_sptr self, int ninputs, int noutputs) -> bool"""
        return _channels_swig.fading_model_sptr_check_topology(self, *args, **kwargs)

    def alias(self):
        """alias(fading_model_sptr self) -> std::string"""
        return _channels_swig.fading_model_sptr_alias(self)

    def set_block_alias(self, *args, **kwargs):
        """set_block_alias(fading_model_sptr self, std::string name)"""
        return _channels_swig.fading_model_sptr_set_block_alias(self, *args, **kwargs)

    def _post(self, *args, **kwargs):
        """_post(fading_model_sptr self, swig_int_ptr which_port, swig_int_ptr msg)"""
        return _channels_swig.fading_model_sptr__post(self, *args, **kwargs)

    def message_ports_in(self):
        """message_ports_in(fading_model_sptr self) -> swig_int_ptr"""
        return _channels_swig.fading_model_sptr_message_ports_in(self)

    def message_ports_out(self):
        """message_ports_out(fading_model_sptr self) -> swig_int_ptr"""
        return _channels_swig.fading_model_sptr_message_ports_out(self)

fading_model_sptr_swigregister = _channels_swig.fading_model_sptr_swigregister
fading_model_sptr_swigregister(fading_model_sptr)

fading_model_sptr.__repr__ = lambda self: "<gr_block %s (%d)>" % (self.name(), self.unique_id())
fading_model = fading_model.make;

class selective_fading_model_sptr(object):
    """Proxy of C++ boost::shared_ptr<(gr::channels::selective_fading_model)> class"""
    thisown = _swig_property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc='The membership flag')
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(boost::shared_ptr<(gr::channels::selective_fading_model)> self) -> selective_fading_model_sptr
        __init__(boost::shared_ptr<(gr::channels::selective_fading_model)> self, selective_fading_model p) -> selective_fading_model_sptr
        """
        this = _channels_swig.new_selective_fading_model_sptr(*args)
        try: self.this.append(this)
        except: self.this = this
    def __deref__(self):
        """__deref__(selective_fading_model_sptr self) -> selective_fading_model"""
        return _channels_swig.selective_fading_model_sptr___deref__(self)

    __swig_destroy__ = _channels_swig.delete_selective_fading_model_sptr
    __del__ = lambda self : None;
    def make(self, *args, **kwargs):
        """
        make(selective_fading_model_sptr self, unsigned int N, float fDTs, bool LOS, float K, int seed, pmt_vector_float delays, 
            pmt_vector_float mags, int ntaps) -> selective_fading_model_sptr

        fading simulator

        This block implements a basic fading model simulator that can be used to help evaluate, design, and test various signals, waveforms, and algorithms.

        Constructor Specific Documentation:

        Build the channel simulator.

        Args:
            N : The number of sinusiods to use in simulating the channel; 8 is a good value
            fDTs : normalized maximum Doppler frequency, fD * Ts
            LOS : include Line-of-Site path? selects between Rayleigh (NLOS) and Rician (LOS) models
            K : Rician factor (ratio of the specular power to the scattered power)
            seed : a random number to seed the noise generators
            delays : A vector of values the specify the time delay of each impulse
            mags : A vector of values that specifies the magnitude of each impulse
            ntaps : The number of filter taps.
        """
        return _channels_swig.selective_fading_model_sptr_make(self, *args, **kwargs)

    def fDTs(self):
        """fDTs(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_fDTs(self)

    def K(self):
        """K(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_K(self)

    def step(self):
        """step(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_step(self)

    def set_fDTs(self, *args, **kwargs):
        """set_fDTs(selective_fading_model_sptr self, float fDTs)"""
        return _channels_swig.selective_fading_model_sptr_set_fDTs(self, *args, **kwargs)

    def set_K(self, *args, **kwargs):
        """set_K(selective_fading_model_sptr self, float K)"""
        return _channels_swig.selective_fading_model_sptr_set_K(self, *args, **kwargs)

    def set_step(self, *args, **kwargs):
        """set_step(selective_fading_model_sptr self, float step)"""
        return _channels_swig.selective_fading_model_sptr_set_step(self, *args, **kwargs)

    def history(self):
        """history(selective_fading_model_sptr self) -> unsigned int"""
        return _channels_swig.selective_fading_model_sptr_history(self)

    def output_multiple(self):
        """output_multiple(selective_fading_model_sptr self) -> int"""
        return _channels_swig.selective_fading_model_sptr_output_multiple(self)

    def relative_rate(self):
        """relative_rate(selective_fading_model_sptr self) -> double"""
        return _channels_swig.selective_fading_model_sptr_relative_rate(self)

    def start(self):
        """start(selective_fading_model_sptr self) -> bool"""
        return _channels_swig.selective_fading_model_sptr_start(self)

    def stop(self):
        """stop(selective_fading_model_sptr self) -> bool"""
        return _channels_swig.selective_fading_model_sptr_stop(self)

    def nitems_read(self, *args, **kwargs):
        """nitems_read(selective_fading_model_sptr self, unsigned int which_input) -> uint64_t"""
        return _channels_swig.selective_fading_model_sptr_nitems_read(self, *args, **kwargs)

    def nitems_written(self, *args, **kwargs):
        """nitems_written(selective_fading_model_sptr self, unsigned int which_output) -> uint64_t"""
        return _channels_swig.selective_fading_model_sptr_nitems_written(self, *args, **kwargs)

    def max_noutput_items(self):
        """max_noutput_items(selective_fading_model_sptr self) -> int"""
        return _channels_swig.selective_fading_model_sptr_max_noutput_items(self)

    def set_max_noutput_items(self, *args, **kwargs):
        """set_max_noutput_items(selective_fading_model_sptr self, int m)"""
        return _channels_swig.selective_fading_model_sptr_set_max_noutput_items(self, *args, **kwargs)

    def unset_max_noutput_items(self):
        """unset_max_noutput_items(selective_fading_model_sptr self)"""
        return _channels_swig.selective_fading_model_sptr_unset_max_noutput_items(self)

    def is_set_max_noutput_items(self):
        """is_set_max_noutput_items(selective_fading_model_sptr self) -> bool"""
        return _channels_swig.selective_fading_model_sptr_is_set_max_noutput_items(self)

    def max_output_buffer(self, *args, **kwargs):
        """max_output_buffer(selective_fading_model_sptr self, int i) -> long"""
        return _channels_swig.selective_fading_model_sptr_max_output_buffer(self, *args, **kwargs)

    def set_max_output_buffer(self, *args):
        """
        set_max_output_buffer(selective_fading_model_sptr self, long max_output_buffer)
        set_max_output_buffer(selective_fading_model_sptr self, int port, long max_output_buffer)
        """
        return _channels_swig.selective_fading_model_sptr_set_max_output_buffer(self, *args)

    def min_output_buffer(self, *args, **kwargs):
        """min_output_buffer(selective_fading_model_sptr self, int i) -> long"""
        return _channels_swig.selective_fading_model_sptr_min_output_buffer(self, *args, **kwargs)

    def set_min_output_buffer(self, *args):
        """
        set_min_output_buffer(selective_fading_model_sptr self, long min_output_buffer)
        set_min_output_buffer(selective_fading_model_sptr self, int port, long min_output_buffer)
        """
        return _channels_swig.selective_fading_model_sptr_set_min_output_buffer(self, *args)

    def pc_noutput_items(self):
        """pc_noutput_items(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_noutput_items(self)

    def pc_noutput_items_avg(self):
        """pc_noutput_items_avg(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_noutput_items_avg(self)

    def pc_noutput_items_var(self):
        """pc_noutput_items_var(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_noutput_items_var(self)

    def pc_nproduced(self):
        """pc_nproduced(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_nproduced(self)

    def pc_nproduced_avg(self):
        """pc_nproduced_avg(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_nproduced_avg(self)

    def pc_nproduced_var(self):
        """pc_nproduced_var(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_nproduced_var(self)

    def pc_input_buffers_full(self, *args):
        """
        pc_input_buffers_full(selective_fading_model_sptr self, int which) -> float
        pc_input_buffers_full(selective_fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.selective_fading_model_sptr_pc_input_buffers_full(self, *args)

    def pc_input_buffers_full_avg(self, *args):
        """
        pc_input_buffers_full_avg(selective_fading_model_sptr self, int which) -> float
        pc_input_buffers_full_avg(selective_fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.selective_fading_model_sptr_pc_input_buffers_full_avg(self, *args)

    def pc_input_buffers_full_var(self, *args):
        """
        pc_input_buffers_full_var(selective_fading_model_sptr self, int which) -> float
        pc_input_buffers_full_var(selective_fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.selective_fading_model_sptr_pc_input_buffers_full_var(self, *args)

    def pc_output_buffers_full(self, *args):
        """
        pc_output_buffers_full(selective_fading_model_sptr self, int which) -> float
        pc_output_buffers_full(selective_fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.selective_fading_model_sptr_pc_output_buffers_full(self, *args)

    def pc_output_buffers_full_avg(self, *args):
        """
        pc_output_buffers_full_avg(selective_fading_model_sptr self, int which) -> float
        pc_output_buffers_full_avg(selective_fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.selective_fading_model_sptr_pc_output_buffers_full_avg(self, *args)

    def pc_output_buffers_full_var(self, *args):
        """
        pc_output_buffers_full_var(selective_fading_model_sptr self, int which) -> float
        pc_output_buffers_full_var(selective_fading_model_sptr self) -> pmt_vector_float
        """
        return _channels_swig.selective_fading_model_sptr_pc_output_buffers_full_var(self, *args)

    def pc_work_time(self):
        """pc_work_time(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_work_time(self)

    def pc_work_time_avg(self):
        """pc_work_time_avg(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_work_time_avg(self)

    def pc_work_time_var(self):
        """pc_work_time_var(selective_fading_model_sptr self) -> float"""
        return _channels_swig.selective_fading_model_sptr_pc_work_time_var(self)

    def set_processor_affinity(self, *args, **kwargs):
        """set_processor_affinity(selective_fading_model_sptr self, std::vector< int,std::allocator< int > > const & mask)"""
        return _channels_swig.selective_fading_model_sptr_set_processor_affinity(self, *args, **kwargs)

    def unset_processor_affinity(self):
        """unset_processor_affinity(selective_fading_model_sptr self)"""
        return _channels_swig.selective_fading_model_sptr_unset_processor_affinity(self)

    def processor_affinity(self):
        """processor_affinity(selective_fading_model_sptr self) -> std::vector< int,std::allocator< int > >"""
        return _channels_swig.selective_fading_model_sptr_processor_affinity(self)

    def active_thread_priority(self):
        """active_thread_priority(selective_fading_model_sptr self) -> int"""
        return _channels_swig.selective_fading_model_sptr_active_thread_priority(self)

    def thread_priority(self):
        """thread_priority(selective_fading_model_sptr self) -> int"""
        return _channels_swig.selective_fading_model_sptr_thread_priority(self)

    def set_thread_priority(self, *args, **kwargs):
        """set_thread_priority(selective_fading_model_sptr self, int priority) -> int"""
        return _channels_swig.selective_fading_model_sptr_set_thread_priority(self, *args, **kwargs)

    def name(self):
        """name(selective_fading_model_sptr self) -> std::string"""
        return _channels_swig.selective_fading_model_sptr_name(self)

    def symbol_name(self):
        """symbol_name(selective_fading_model_sptr self) -> std::string"""
        return _channels_swig.selective_fading_model_sptr_symbol_name(self)

    def input_signature(self):
        """input_signature(selective_fading_model_sptr self) -> io_signature_sptr"""
        return _channels_swig.selective_fading_model_sptr_input_signature(self)

    def output_signature(self):
        """output_signature(selective_fading_model_sptr self) -> io_signature_sptr"""
        return _channels_swig.selective_fading_model_sptr_output_signature(self)

    def unique_id(self):
        """unique_id(selective_fading_model_sptr self) -> long"""
        return _channels_swig.selective_fading_model_sptr_unique_id(self)

    def to_basic_block(self):
        """to_basic_block(selective_fading_model_sptr self) -> basic_block_sptr"""
        return _channels_swig.selective_fading_model_sptr_to_basic_block(self)

    def check_topology(self, *args, **kwargs):
        """check_topology(selective_fading_model_sptr self, int ninputs, int noutputs) -> bool"""
        return _channels_swig.selective_fading_model_sptr_check_topology(self, *args, **kwargs)

    def alias(self):
        """alias(selective_fading_model_sptr self) -> std::string"""
        return _channels_swig.selective_fading_model_sptr_alias(self)

    def set_block_alias(self, *args, **kwargs):
        """set_block_alias(selective_fading_model_sptr self, std::string name)"""
        return _channels_swig.selective_fading_model_sptr_set_block_alias(self, *args, **kwargs)

    def _post(self, *args, **kwargs):
        """_post(selective_fading_model_sptr self, swig_int_ptr which_port, swig_int_ptr msg)"""
        return _channels_swig.selective_fading_model_sptr__post(self, *args, **kwargs)

    def message_ports_in(self):
        """message_ports_in(selective_fading_model_sptr self) -> swig_int_ptr"""
        return _channels_swig.selective_fading_model_sptr_message_ports_in(self)

    def message_ports_out(self):
        """message_ports_out(selective_fading_model_sptr self) -> swig_int_ptr"""
        return _channels_swig.selective_fading_model_sptr_message_ports_out(self)

selective_fading_model_sptr_swigregister = _channels_swig.selective_fading_model_sptr_swigregister
selective_fading_model_sptr_swigregister(selective_fading_model_sptr)

selective_fading_model_sptr.__repr__ = lambda self: "<gr_block %s (%d)>" % (self.name(), self.unique_id())
selective_fading_model = selective_fading_model.make;



